diff --git a/benchtests/bench-strcat.c b/benchtests/bench-strcat.c
index 749318e37e..890b34b4c1 100644
--- a/benchtests/bench-strcat.c
+++ b/benchtests/bench-strcat.c
@@ -35,6 +35,7 @@
 # define SMALL_CHAR 1273
 #endif /* WIDE */
 
+#include "json-lib.h"
 
 typedef CHAR *(*proto_t) (CHAR *, const CHAR *);
 
@@ -49,7 +50,7 @@ IMPL (STRCAT, 1)
 IMPL (generic_strcat, 0)
 
 static void
-do_one_test (impl_t *impl, CHAR *dst, const CHAR *src)
+do_one_test (json_ctx_t *json_ctx, impl_t *impl, CHAR *dst, const CHAR *src)
 {
   size_t k = STRLEN (dst), i, iters = INNER_LOOP_ITERS_LARGE;
   timing_t start, stop, cur;
@@ -64,7 +65,8 @@ do_one_test (impl_t *impl, CHAR *dst, const CHAR *src)
 
   if (STRCMP (dst + k, src) != 0)
     {
-      error (0, 0, "Wrong result in function %s dst \"%" sfmt "\" src \"%" sfmt "\"",
+      error (0, 0,
+	     "Wrong result in function %s dst \"%" sfmt "\" src \"%" sfmt "\"",
 	     impl->name, dst, src);
       ret = 1;
       return;
@@ -80,11 +82,12 @@ do_one_test (impl_t *impl, CHAR *dst, const CHAR *src)
 
   TIMING_DIFF (cur, start, stop);
 
-  TIMING_PRINT_MEAN ((double) cur, (double) iters);
+  json_element_double (json_ctx, (double) cur / (double) iters);
 }
 
 static void
-do_test (size_t align1, size_t align2, size_t len1, size_t len2, int max_char)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len1,
+	 size_t len2, int max_char)
 {
   size_t i;
   CHAR *s1, *s2;
@@ -107,53 +110,112 @@ do_test (size_t align1, size_t align2, size_t len1, size_t len2, int max_char)
   for (i = 0; i < len2; i++)
     s2[i] = 32 + 23 * i % (max_char - 32);
 
-  printf ("Length %4zd/%4zd, alignment %2zd/%2zd:", len1, len2, align1, align2);
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "align1", align1);
+  json_attr_uint (json_ctx, "align2", align2);
+  json_attr_uint (json_ctx, "len1", len1);
+  json_attr_uint (json_ctx, "len2", len2);
+  json_attr_uint (json_ctx, "max_char", max_char);
+
+  json_array_begin (json_ctx, "timings");
 
   FOR_EACH_IMPL (impl, 0)
     {
       s2[len2] = '\0';
-      do_one_test (impl, s2, s1);
+      do_one_test (json_ctx, impl, s2, s1);
     }
 
-  putchar ('\n');
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
 }
 
 int
 test_main (void)
 {
+  json_ctx_t json_ctx;
   size_t i;
 
   test_init ();
 
-  printf ("%28s", "");
+  test_init ();
+
+  json_init (&json_ctx, 0, stdout);
+
+  json_document_begin (&json_ctx);
+  json_attr_string (&json_ctx, "timing_type", TIMING_TYPE);
+
+  json_attr_object_begin (&json_ctx, "functions");
+  json_attr_object_begin (&json_ctx, TEST_NAME);
+  json_attr_string (&json_ctx, "bench-variant", "");
+
+  json_array_begin (&json_ctx, "ifuncs");
   FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
+    json_element_string (&json_ctx, impl->name);
+  json_array_end (&json_ctx);
+
+  json_array_begin (&json_ctx, "results");
 
   for (i = 0; i < 16; ++i)
     {
-      do_test (0, 0, i, i, SMALL_CHAR);
-      do_test (0, 0, i, i, BIG_CHAR);
-      do_test (0, i, i, i, SMALL_CHAR);
-      do_test (i, 0, i, i, BIG_CHAR);
+      do_test (&json_ctx, 0, 0, i, i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, i, i, BIG_CHAR);
+      do_test (&json_ctx, 0, i, i, i, SMALL_CHAR);
+      do_test (&json_ctx, i, 0, i, i, BIG_CHAR);
     }
 
   for (i = 1; i < 8; ++i)
     {
-      do_test (0, 0, 8 << i, 8 << i, SMALL_CHAR);
-      do_test (8 - i, 2 * i, 8 << i, 8 << i, SMALL_CHAR);
-      do_test (0, 0, 8 << i, 2 << i, SMALL_CHAR);
-      do_test (8 - i, 2 * i, 8 << i, 2 << i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, 8 << i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 8 - i, 2 * i, 8 << i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, 8 << i, 2 << i, SMALL_CHAR);
+      do_test (&json_ctx, 8 - i, 2 * i, 8 << i, 2 << i, SMALL_CHAR);
     }
 
   for (i = 1; i < 8; ++i)
     {
-      do_test (i, 2 * i, 8 << i, 1, SMALL_CHAR);
-      do_test (2 * i, i, 8 << i, 1, BIG_CHAR);
-      do_test (i, i, 8 << i, 10, SMALL_CHAR);
-      do_test (i, i, 8 << i, 10, BIG_CHAR);
+      do_test (&json_ctx, i, 2 * i, 8 << i, 1, SMALL_CHAR);
+      do_test (&json_ctx, 2 * i, i, 8 << i, 1, BIG_CHAR);
+      do_test (&json_ctx, i, i, 8 << i, 10, SMALL_CHAR);
+      do_test (&json_ctx, i, i, 8 << i, 10, BIG_CHAR);
+    }
+
+  for (i = 32; i < 256; i += 32)
+    {
+      do_test (&json_ctx, 1, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, i, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, i, i, i, 31, SMALL_CHAR);
     }
 
+  for (; i < 512; i += 64)
+    {
+      do_test (&json_ctx, 1, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, i, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, i, i, i, 31, SMALL_CHAR);
+    }
+
+  for (; i < 1024; i += 128)
+    {
+      do_test (&json_ctx, 1, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, i, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, i, i, i, 31, SMALL_CHAR);
+    }
+
+  for (; i < 2048; i += 256)
+    {
+      do_test (&json_ctx, 1, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, i, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, i, 31, SMALL_CHAR);
+      do_test (&json_ctx, i, i, i, 31, SMALL_CHAR);
+    }
+
+  json_array_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_document_end (&json_ctx);
+
   return ret;
 }
 
diff --git a/benchtests/bench-strcpy.c b/benchtests/bench-strcpy.c
index 29deb8a46a..af8673e137 100644
--- a/benchtests/bench-strcpy.c
+++ b/benchtests/bench-strcpy.c
@@ -26,16 +26,18 @@
 # define SMALL_CHAR 127
 #endif
 
+#include "json-lib.h"
+
 #ifndef STRCPY_RESULT
 # define STRCPY_RESULT(dst, len) dst
 # define TEST_MAIN
 # ifndef WIDE
-#  define TEST_NAME "strcpy"
+#   define TEST_NAME "strcpy"
 # else
-#  define TEST_NAME "wcscpy"
-#  define generic_strcpy generic_wcscpy
+#   define TEST_NAME "wcscpy"
+#   define generic_strcpy generic_wcscpy
 # endif
-#include "bench-string.h"
+# include "bench-string.h"
 
 CHAR *
 generic_strcpy (CHAR *dst, const CHAR *src)
@@ -51,8 +53,8 @@ IMPL (generic_strcpy, 0)
 typedef CHAR *(*proto_t) (CHAR *, const CHAR *);
 
 static void
-do_one_test (impl_t *impl, CHAR *dst, const CHAR *src,
-	     size_t len __attribute__((unused)))
+do_one_test (json_ctx_t *json_ctx, impl_t *impl, CHAR *dst, const CHAR *src,
+	     size_t len __attribute__ ((unused)))
 {
   size_t i, iters = INNER_LOOP_ITERS;
   timing_t start, stop, cur;
@@ -77,23 +79,24 @@ do_one_test (impl_t *impl, CHAR *dst, const CHAR *src,
   TIMING_NOW (start);
   for (i = 0; i < iters; ++i)
     {
-	  CALL (impl, dst, src);
+      CALL (impl, dst, src);
     }
   TIMING_NOW (stop);
 
   TIMING_DIFF (cur, start, stop);
 
-  TIMING_PRINT_MEAN ((double) cur, (double) iters);
+  json_element_double (json_ctx, (double) cur / (double) iters);
 }
 
 static void
-do_test (size_t align1, size_t align2, size_t len, int max_char)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len,
+	 int max_char)
 {
   size_t i;
   CHAR *s1, *s2;
-/* For wcscpy: align1 and align2 here mean alignment not in bytes,
-   but in wchar_ts, in bytes it will equal to align * (sizeof (wchar_t))
-   len for wcschr here isn't in bytes but it's number of wchar_t symbols.  */
+  /* For wcscpy: align1 and align2 here mean alignment not in bytes,
+     but in wchar_ts, in bytes it will equal to align * (sizeof (wchar_t))
+     len for wcschr here isn't in bytes but it's number of wchar_t symbols.  */
   align1 &= 7;
   if ((align1 + len) * sizeof (CHAR) >= page_size)
     return;
@@ -109,65 +112,96 @@ do_test (size_t align1, size_t align2, size_t len, int max_char)
     s1[i] = 32 + 23 * i % (max_char - 32);
   s1[len] = 0;
 
-  printf ("Length %4zd, alignments in bytes %2zd/%2zd:", len,
-	  align1 * sizeof (CHAR), align2 * sizeof (CHAR));
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "align1", align1);
+  json_attr_uint (json_ctx, "align2", align2);
+  json_attr_uint (json_ctx, "len", len);
+  json_attr_uint (json_ctx, "max_char", max_char);
+
+  json_array_begin (json_ctx, "timings");
 
   FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, s2, s1, len);
+    do_one_test (json_ctx, impl, s2, s1, len);
 
-  putchar ('\n');
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
 }
 
 int
 test_main (void)
 {
+  json_ctx_t json_ctx;
   size_t i;
 
   test_init ();
 
-  printf ("%23s", "");
+  json_init (&json_ctx, 0, stdout);
+
+  json_document_begin (&json_ctx);
+  json_attr_string (&json_ctx, "timing_type", TIMING_TYPE);
+
+  json_attr_object_begin (&json_ctx, "functions");
+  json_attr_object_begin (&json_ctx, TEST_NAME);
+  json_attr_string (&json_ctx, "bench-variant", "");
+
+  json_array_begin (&json_ctx, "ifuncs");
   FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
+    json_element_string (&json_ctx, impl->name);
+  json_array_end (&json_ctx);
+
+  json_array_begin (&json_ctx, "results");
 
   for (i = 0; i < 16; ++i)
     {
-      do_test (0, 0, i, SMALL_CHAR);
-      do_test (0, 0, i, BIG_CHAR);
-      do_test (0, i, i, SMALL_CHAR);
-      do_test (i, 0, i, BIG_CHAR);
+      do_test (&json_ctx, 0, 0, i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, i, BIG_CHAR);
+      do_test (&json_ctx, 0, i, i, SMALL_CHAR);
+      do_test (&json_ctx, i, 0, i, BIG_CHAR);
     }
 
   for (i = 1; i < 8; ++i)
     {
-      do_test (0, 0, 8 << i, SMALL_CHAR);
-      do_test (8 - i, 2 * i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 8 - i, 2 * i, 8 << i, SMALL_CHAR);
     }
 
   for (i = 1; i < 8; ++i)
     {
-      do_test (i, 2 * i, 8 << i, SMALL_CHAR);
-      do_test (2 * i, i, 8 << i, BIG_CHAR);
-      do_test (i, i, 8 << i, SMALL_CHAR);
-      do_test (i, i, 8 << i, BIG_CHAR);
+      do_test (&json_ctx, i, 2 * i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 2 * i, i, 8 << i, BIG_CHAR);
+      do_test (&json_ctx, i, i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, i, i, 8 << i, BIG_CHAR);
     }
 
-  for (i = 16; i <= 512; i+=4)
+  for (i = 16; i <= 512; i += 4)
     {
-      do_test (0, 4, i, SMALL_CHAR);
-      do_test (4, 0, i, BIG_CHAR);
-      do_test (4, 4, i, SMALL_CHAR);
-      do_test (2, 2, i, BIG_CHAR);
-      do_test (2, 6, i, SMALL_CHAR);
-      do_test (6, 2, i, BIG_CHAR);
-      do_test (1, 7, i, SMALL_CHAR);
-      do_test (7, 1, i, BIG_CHAR);
-      do_test (3, 4, i, SMALL_CHAR);
-      do_test (4, 3, i, BIG_CHAR);
-      do_test (5, 7, i, SMALL_CHAR);
-      do_test (7, 5, i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 4, i, SMALL_CHAR);
+      do_test (&json_ctx, 4, 0, i, BIG_CHAR);
+      do_test (&json_ctx, 4, 4, i, SMALL_CHAR);
+      do_test (&json_ctx, 2, 2, i, BIG_CHAR);
+      do_test (&json_ctx, 2, 6, i, SMALL_CHAR);
+      do_test (&json_ctx, 6, 2, i, BIG_CHAR);
+      do_test (&json_ctx, 1, 7, i, SMALL_CHAR);
+      do_test (&json_ctx, 7, 1, i, BIG_CHAR);
+      do_test (&json_ctx, 3, 4, i, SMALL_CHAR);
+      do_test (&json_ctx, 4, 3, i, BIG_CHAR);
+      do_test (&json_ctx, 5, 7, i, SMALL_CHAR);
+      do_test (&json_ctx, 7, 5, i, SMALL_CHAR);
     }
 
+  for (i = 1; i < 2048; i += i)
+    {
+      do_test (&json_ctx, 1, 0, i, SMALL_CHAR);
+      do_test (&json_ctx, 0, i, i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, i, SMALL_CHAR);
+      do_test (&json_ctx, i, i, i, SMALL_CHAR);
+    }
+
+  json_array_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_document_end (&json_ctx);
+
   return ret;
 }
 
diff --git a/benchtests/bench-strncat.c b/benchtests/bench-strncat.c
index b148c55279..5ccc09a4f8 100644
--- a/benchtests/bench-strncat.c
+++ b/benchtests/bench-strncat.c
@@ -33,6 +33,8 @@
 # define SMALL_CHAR 1273
 #endif /* WIDE */
 
+#include "json-lib.h"
+
 typedef CHAR *(*proto_t) (CHAR *, const CHAR *, size_t);
 
 CHAR *
@@ -49,7 +51,8 @@ IMPL (STRNCAT, 2)
 IMPL (generic_strncat, 0)
 
 static void
-do_one_test (impl_t *impl, CHAR *dst, const CHAR *src, size_t n)
+do_one_test (json_ctx_t *json_ctx, impl_t *impl, CHAR *dst, const CHAR *src,
+	     size_t n)
 {
   size_t k = STRLEN (dst), i, iters = INNER_LOOP_ITERS8;
   timing_t start, stop, cur;
@@ -65,8 +68,7 @@ do_one_test (impl_t *impl, CHAR *dst, const CHAR *src, size_t n)
   size_t len = STRLEN (src);
   if (MEMCMP (dst + k, src, len + 1 > n ? n : len + 1) != 0)
     {
-      error (0, 0, "Incorrect concatenation in function %s",
-	     impl->name);
+      error (0, 0, "Incorrect concatenation in function %s", impl->name);
       ret = 1;
       return;
     }
@@ -88,12 +90,12 @@ do_one_test (impl_t *impl, CHAR *dst, const CHAR *src, size_t n)
 
   TIMING_DIFF (cur, start, stop);
 
-  TIMING_PRINT_MEAN ((double) cur, (double) iters);
+  json_element_double (json_ctx, (double) cur / (double) iters);
 }
 
 static void
-do_test (size_t align1, size_t align2, size_t len1, size_t len2,
-	 size_t n, int max_char)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len1,
+	 size_t len2, size_t n, int max_char)
 {
   size_t i;
   CHAR *s1, *s2;
@@ -118,53 +120,93 @@ do_test (size_t align1, size_t align2, size_t len1, size_t len2,
   for (i = 0; i < len2; i++)
     s2[i] = 32 + 23 * i % (max_char - 32);
 
-  printf ("Length %4zd/%4zd, alignment %2zd/%2zd, N %4zd:",
-	  len1, len2, align1, align2, n);
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "align1", align1);
+  json_attr_uint (json_ctx, "align2", align2);
+  json_attr_uint (json_ctx, "len1", len1);
+  json_attr_uint (json_ctx, "len2", len2);
+  json_attr_uint (json_ctx, "n", n);
+  json_attr_uint (json_ctx, "max_char", max_char);
+
+  json_array_begin (json_ctx, "timings");
 
   FOR_EACH_IMPL (impl, 0)
     {
       s2[len2] = '\0';
-      do_one_test (impl, s2, s1, n);
+      do_one_test (json_ctx, impl, s2, s1, n);
     }
 
-  putchar ('\n');
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
 }
 
 int
 main (void)
 {
+  json_ctx_t json_ctx;
   size_t i, n;
 
   test_init ();
 
-  printf ("%28s", "");
+  json_init (&json_ctx, 0, stdout);
+
+  json_document_begin (&json_ctx);
+  json_attr_string (&json_ctx, "timing_type", TIMING_TYPE);
+
+  json_attr_object_begin (&json_ctx, "functions");
+  json_attr_object_begin (&json_ctx, TEST_NAME);
+  json_attr_string (&json_ctx, "bench-variant", "");
+
+  json_array_begin (&json_ctx, "ifuncs");
   FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
+    json_element_string (&json_ctx, impl->name);
+  json_array_end (&json_ctx);
+
+  json_array_begin (&json_ctx, "results");
 
-  for (n = 2; n <= 2048; n*=4)
+  for (n = 2; n <= 2048; n *= 4)
     {
-      do_test (0, 2, 2, 2, n, SMALL_CHAR);
-      do_test (0, 0, 4, 4, n, SMALL_CHAR);
-      do_test (4, 0, 4, 4, n, BIG_CHAR);
-      do_test (0, 0, 8, 8, n, SMALL_CHAR);
-      do_test (0, 8, 8, 8, n, SMALL_CHAR);
+      do_test (&json_ctx, 0, 2, 2, 2, n, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, 4, 4, n, SMALL_CHAR);
+      do_test (&json_ctx, 4, 0, 4, 4, n, BIG_CHAR);
+      do_test (&json_ctx, 0, 0, 8, 8, n, SMALL_CHAR);
+      do_test (&json_ctx, 0, 8, 8, 8, n, SMALL_CHAR);
 
       for (i = 1; i < 8; ++i)
 	{
-	  do_test (0, 0, 8 << i, 8 << i, n, SMALL_CHAR);
-	  do_test (8 - i, 2 * i, 8 << i, 8 << i, n, SMALL_CHAR);
-	  do_test (0, 0, 8 << i, 2 << i, n, SMALL_CHAR);
-	  do_test (8 - i, 2 * i, 8 << i, 2 << i, n, SMALL_CHAR);
+	  do_test (&json_ctx, 0, 0, 8 << i, 8 << i, n, SMALL_CHAR);
+	  do_test (&json_ctx, 8 - i, 2 * i, 8 << i, 8 << i, n, SMALL_CHAR);
+	  do_test (&json_ctx, 0, 0, 8 << i, 2 << i, n, SMALL_CHAR);
+	  do_test (&json_ctx, 8 - i, 2 * i, 8 << i, 2 << i, n, SMALL_CHAR);
 	}
 
       for (i = 1; i < 8; ++i)
 	{
-	  do_test (i, 2 * i, 8 << i, 1, n, SMALL_CHAR);
-	  do_test (2 * i, i, 8 << i, 1, n, BIG_CHAR);
-	  do_test (i, i, 8 << i, 10, n, SMALL_CHAR);
+	  do_test (&json_ctx, i, 2 * i, 8 << i, 1, n, SMALL_CHAR);
+	  do_test (&json_ctx, 2 * i, i, 8 << i, 1, n, BIG_CHAR);
+	  do_test (&json_ctx, i, i, 8 << i, 10, n, SMALL_CHAR);
 	}
     }
 
+  for (i = 128; i < 2048; i += i)
+    {
+      for (n = i - 64; n <= i + 64; n += 32)
+	{
+	  do_test (&json_ctx, 1, 0, i, i, n, SMALL_CHAR);
+	  do_test (&json_ctx, 0, i, i, i, n, SMALL_CHAR);
+	  do_test (&json_ctx, 0, 0, i, i, n, SMALL_CHAR);
+	  do_test (&json_ctx, i, i, i, i, n, SMALL_CHAR);
+	  do_test (&json_ctx, 1, 0, i, n, i, SMALL_CHAR);
+	  do_test (&json_ctx, 0, i, i, n, i, SMALL_CHAR);
+	  do_test (&json_ctx, 0, 0, i, n, i, SMALL_CHAR);
+	  do_test (&json_ctx, i, i, i, n, i, SMALL_CHAR);
+	}
+    }
+
+  json_array_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_document_end (&json_ctx);
+
   return ret;
 }
diff --git a/benchtests/bench-strncpy.c b/benchtests/bench-strncpy.c
index 8207d99f4d..f621cbfe09 100644
--- a/benchtests/bench-strncpy.c
+++ b/benchtests/bench-strncpy.c
@@ -24,6 +24,8 @@
 # define SMALL_CHAR 127
 #endif /* !WIDE */
 
+#include "json-lib.h"
+
 #ifndef STRNCPY_RESULT
 # define STRNCPY_RESULT(dst, len, n) dst
 # define TEST_MAIN
@@ -52,7 +54,8 @@ IMPL (generic_strncpy, 0)
 typedef CHAR *(*proto_t) (CHAR *, const CHAR *, size_t);
 
 static void
-do_one_test (impl_t *impl, CHAR *dst, const CHAR *src, size_t len, size_t n)
+do_one_test (json_ctx_t *json_ctx, impl_t *impl, CHAR *dst, const CHAR *src,
+	     size_t len, size_t n)
 {
   size_t i, iters = INNER_LOOP_ITERS_LARGE * (4 / CHARBYTES);
   timing_t start, stop, cur;
@@ -77,7 +80,7 @@ do_one_test (impl_t *impl, CHAR *dst, const CHAR *src, size_t len, size_t n)
       size_t i;
 
       for (i = len; i < n; ++i)
-	if (dst [i] != '\0')
+	if (dst[i] != '\0')
 	  {
 	    error (0, 0, "Wrong result in function %s", impl->name);
 	    ret = 1;
@@ -94,17 +97,18 @@ do_one_test (impl_t *impl, CHAR *dst, const CHAR *src, size_t len, size_t n)
 
   TIMING_DIFF (cur, start, stop);
 
-  TIMING_PRINT_MEAN ((double) cur, (double) iters);
+  json_element_double (json_ctx, (double) cur / (double) iters);
 }
 
 static void
-do_test (size_t align1, size_t align2, size_t len, size_t n, int max_char)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len,
+	 size_t n, int max_char)
 {
   size_t i;
   CHAR *s1, *s2;
 
-/* For wcsncpy: align1 and align2 here mean alignment not in bytes,
-   but in wchar_ts, in bytes it will equal to align * (sizeof (wchar_t)).  */
+  /* For wcsncpy: align1 and align2 here mean alignment not in bytes,
+     but in wchar_ts, in bytes it will equal to align * (sizeof (wchar_t)).  */
   align1 &= 7;
   if ((align1 + len) * sizeof (CHAR) >= page_size)
     return;
@@ -123,46 +127,86 @@ do_test (size_t align1, size_t align2, size_t len, size_t n, int max_char)
        ++i)
     s1[i] = 32 + 32 * i % (max_char - 32);
 
-  printf ("Length %4zd, n %4zd, alignment %2zd/%2zd:", len, n, align1, align2);
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "align1", align1);
+  json_attr_uint (json_ctx, "align2", align2);
+  json_attr_uint (json_ctx, "len", len);
+  json_attr_uint (json_ctx, "n", n);
+  json_attr_uint (json_ctx, "max_char", max_char);
+
+  json_array_begin (json_ctx, "timings");
 
   FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, s2, s1, len, n);
+    do_one_test (json_ctx, impl, s2, s1, len, n);
 
-  putchar ('\n');
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
 }
 
 static int
 test_main (void)
 {
-  size_t i;
+  json_ctx_t json_ctx;
+  size_t i, j;
 
   test_init ();
 
-  printf ("%28s", "");
+  json_init (&json_ctx, 0, stdout);
+
+  json_document_begin (&json_ctx);
+  json_attr_string (&json_ctx, "timing_type", TIMING_TYPE);
+
+  json_attr_object_begin (&json_ctx, "functions");
+  json_attr_object_begin (&json_ctx, TEST_NAME);
+  json_attr_string (&json_ctx, "bench-variant", "");
+
+  json_array_begin (&json_ctx, "ifuncs");
   FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
+    json_element_string (&json_ctx, impl->name);
+  json_array_end (&json_ctx);
+
+  json_array_begin (&json_ctx, "results");
 
   for (i = 1; i < 8; ++i)
     {
-      do_test (i, i, 16, 16, SMALL_CHAR);
-      do_test (i, i, 16, 16, BIG_CHAR);
-      do_test (i, 2 * i, 16, 16, SMALL_CHAR);
-      do_test (2 * i, i, 16, 16, BIG_CHAR);
-      do_test (8 - i, 2 * i, 1 << i, 2 << i, SMALL_CHAR);
-      do_test (2 * i, 8 - i, 2 << i, 1 << i, SMALL_CHAR);
-      do_test (8 - i, 2 * i, 1 << i, 2 << i, BIG_CHAR);
-      do_test (2 * i, 8 - i, 2 << i, 1 << i, BIG_CHAR);
+      do_test (&json_ctx, i, i, 16, 16, SMALL_CHAR);
+      do_test (&json_ctx, i, i, 16, 16, BIG_CHAR);
+      do_test (&json_ctx, i, 2 * i, 16, 16, SMALL_CHAR);
+      do_test (&json_ctx, 2 * i, i, 16, 16, BIG_CHAR);
+      do_test (&json_ctx, 8 - i, 2 * i, 1 << i, 2 << i, SMALL_CHAR);
+      do_test (&json_ctx, 2 * i, 8 - i, 2 << i, 1 << i, SMALL_CHAR);
+      do_test (&json_ctx, 8 - i, 2 * i, 1 << i, 2 << i, BIG_CHAR);
+      do_test (&json_ctx, 2 * i, 8 - i, 2 << i, 1 << i, BIG_CHAR);
     }
 
   for (i = 1; i < 8; ++i)
     {
-      do_test (0, 0, 4 << i, 8 << i, SMALL_CHAR);
-      do_test (0, 0, 16 << i, 8 << i, SMALL_CHAR);
-      do_test (8 - i, 2 * i, 4 << i, 8 << i, SMALL_CHAR);
-      do_test (8 - i, 2 * i, 16 << i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, 4 << i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 0, 0, 16 << i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 8 - i, 2 * i, 4 << i, 8 << i, SMALL_CHAR);
+      do_test (&json_ctx, 8 - i, 2 * i, 16 << i, 8 << i, SMALL_CHAR);
     }
 
+  for (i = 128; i < 2048; i += i)
+    {
+      for (j = i - 64; j <= i + 64; j += 32)
+	{
+	  do_test (&json_ctx, 1, 0, i, j, SMALL_CHAR);
+	  do_test (&json_ctx, 0, i, i, j, SMALL_CHAR);
+	  do_test (&json_ctx, 0, 0, i, j, SMALL_CHAR);
+	  do_test (&json_ctx, i, i, i, j, SMALL_CHAR);
+	  do_test (&json_ctx, 1, 0, j, i, SMALL_CHAR);
+	  do_test (&json_ctx, 0, i, j, i, SMALL_CHAR);
+	  do_test (&json_ctx, 0, 0, j, i, SMALL_CHAR);
+	  do_test (&json_ctx, i, i, j, i, SMALL_CHAR);
+	}
+    }
+
+  json_array_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_document_end (&json_ctx);
+
   return ret;
 }
 